# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.

from cmf.monitor.json_metrics_utils import get_leaf_dict


class JsonParser(object):
  def __init__(self, json_dict):
    """
    May raise ParseError if the json structure is not what
    we expect.
    """
    self._json = json_dict
    self.jvm = get_leaf_dict(self._json, 'jvm', 'metrics')
    self.tasktracker = get_leaf_dict(self._json, 'mapred', 'tasktracker')
    # Beware getting the rpc metrics. See OPSAPS-3319.

#
# This is what the TT json looks like:
#
SAMPLE = """
  {
    "jvm":{
      "metrics":[
        [
          {
            "hostName":"dsom",
            "processName":"TaskTracker",
            "sessionId":""
          },
          {
            "gcCount":1,
            "gcTimeMillis":4,
            "logError":0,
            "logFatal":0,
            "logInfo":28,
            "logWarn":1,
            "maxMemoryM":177.8125,
            "memHeapCommittedM":118.875,
            "memHeapUsedM":26.387619,
            "memNonHeapCommittedM":23.1875,
            "memNonHeapUsedM":17.199066,
            "threadsBlocked":1,
            "threadsNew":2,
            "threadsRunnable":3,
            "threadsTerminated":4,
            "threadsTimedWaiting":5,
            "threadsWaiting":6
          }
        ]
      ]
    },
    "mapred":{
      "shuffleOutput":[
        [
          {
            "hostName":"dsom",
            "sessionId":""
          },
          {
            "shuffle_failed_outputs":0,
            "shuffle_handler_busy_percent":0.0,
            "shuffle_output_bytes":0,
            "shuffle_success_outputs":0
          }
        ]
      ],
      "tasktracker":[
        [
          {
            "hostName":"dsom",
            "sessionId":""
          },
          {
            "mapTaskSlots":2,
            "maps_running":0,
            "reduceTaskSlots":2,
            "reduces_running":0,
            "tasks_completed":0,
            "tasks_failed_ping":0,
            "tasks_failed_timeout":0
          }
        ]
      ]
    },
    "rpc":{
      "detailed-metrics":[
        [
          {
            "hostName":"dsom",
            "port":"48060"
          },
          {
            "getProtocolVersion_avg_time":0,
            "getProtocolVersion_num_ops":0
          }
        ]
      ],
      "metrics":[
        [
          {
            "hostName":"dsom",
            "port":"48060"
          },
          {
            "NumOpenConnections":0,
            "ReceivedBytes":0,
            "RpcProcessingTime_avg_time":0,
            "RpcProcessingTime_num_ops":0,
            "RpcQueueTime_avg_time":0,
            "RpcQueueTime_num_ops":0,
            "SentBytes":0,
            "callQueueLen":0,
            "rpcAuthenticationFailures":0,
            "rpcAuthenticationSuccesses":0,
            "rpcAuthorizationFailures":0,
            "rpcAuthorizationSuccesses":0
          }
        ],
        [
          {
            "hostName":"dsom",
            "port":"48061"
          },
          {
            "NumOpenConnections":0,
            "ReceivedBytes":0,
            "RpcProcessingTime_avg_time":0,
            "RpcProcessingTime_num_ops":0,
            "RpcQueueTime_avg_time":0,
            "RpcQueueTime_num_ops":0,
            "SentBytes":0,
            "callQueueLen":0,
            "rpcAuthenticationFailures":0,
            "rpcAuthenticationSuccesses":0,
            "rpcAuthorizationFailures":0,
            "rpcAuthorizationSuccesses":0
          }
        ]
      ]
    },
    "ugi":{
      "ugi":[
        [
          {
            "hostName":"dsom"
          },
          {
            "loginFailure_avg_time":0,
            "loginFailure_num_ops":0,
            "loginSuccess_avg_time":0,
            "loginSuccess_num_ops":0
          }
        ]
      ]
    }
  }
  """
