// (c) Copyright 2012 Cloudera, Inc. All rights reserved.

define(["cloudera/Util","cloudera/common/DateUtil","cloudera/chart/TimeBrowserState","cloudera/chart/TimeRange"],function(e,t,n,r){var i=e.getServerTimezoneOffset(),s=2009;describe("TimeBrowserState Tests",function(){var t,i={firstDate:new Date(910),lastDate:new Date(1e3),firstVisibleDate:new Date(950),lastVisibleDate:new Date(1e3),markerDate:new Date(1e3),isCurrentMode:!0};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(e,"getServerNow").andReturn(new Date(1e3)),t=new n(i),t.getContainerWidth=function(){return s}}),afterEach(function(){}),it("should select a range.",function(){t.setSelectedRange(new r(new Date(940),new Date(960))),expect(t.firstDate.getTime()).toEqual(910),expect(t.lastDate.getTime()).toEqual(1e3),expect(t.firstVisibleDate.getTime()).toEqual(940),expect(t.lastVisibleDate.getTime()).toEqual(960)}),it("should select a range but not in the future.",function(){t.setSelectedRange(new r(new Date(950),new Date(1020))),expect(t.firstDate.getTime()).toEqual(910),expect(t.lastDate.getTime()).toEqual(1e3),expect(t.firstVisibleDate.getTime()).toEqual(930),expect(t.lastVisibleDate.getTime()).toEqual(1e3)}),it("should select a range even if the input is reversed.",function(){t.setSelectedRange(new r(new Date(1020),new Date(950))),expect(t.firstDate.getTime()).toEqual(910),expect(t.lastDate.getTime()).toEqual(1e3),expect(t.firstVisibleDate.getTime()).toEqual(930),expect(t.lastVisibleDate.getTime()).toEqual(1e3)}),it("should zoomOut in the present.",function(){t.zoomOut(),expect(t.firstDate.getTime()).toEqual(820),expect(t.lastDate.getTime()).toEqual(1e3),expect(t.firstVisibleDate.getTime()).toEqual(950),expect(t.lastVisibleDate.getTime()).toEqual(1e3)}),it("should zoom in.",function(){t.zoomIn(),expect(t.firstDate.getTime()).toEqual(950),expect(t.lastDate.getTime()).toEqual(1e3),expect(t.firstVisibleDate.getTime()).toEqual(950),expect(t.lastVisibleDate.getTime()).toEqual(1e3)})}),describe("TimeBrowserState Tests with options2",function(){var t={firstDate:new Date(810),lastDate:new Date(900),firstVisibleDate:new Date(850),lastVisibleDate:new Date(900),markerDate:new Date(900),isCurrentMode:!1};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(e,"getServerNow").andReturn(new Date(1e3)),state=new n(t),state.getContainerWidth=function(){return s}}),afterEach(function(){}),it("should zoomOut while in the past.",function(){state.zoomOut(),expect(state.firstDate.getTime()).toEqual(765),expect(state.lastDate.getTime()).toEqual(945),expect(state.firstVisibleDate.getTime()).toEqual(850),expect(state.lastVisibleDate.getTime()).toEqual(900)}),it("should zoomOut with a past end point, but in current mode.",function(){state.setCurrentMode(!0),state.zoomOut(),expect(state.firstDate.getTime()).toEqual(765),expect(state.lastDate.getTime()).toEqual(945),expect(state.firstVisibleDate.getTime()).toEqual(850),expect(state.lastVisibleDate.getTime()).toEqual(900)})}),describe("TimeBrowserState with options3",function(){var t="tc_timeControl",r={firstDate:new Date(900),lastDate:new Date(1e3),firstVisibleDate:new Date(950),lastVisibleDate:new Date(1e3),isCurrentMode:!0,markerDate:new Date(975),markerContainer:"#"+t};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(e,"getServerNow").andReturn(new Date(1e3)),e.setServerTimezoneOffset(0),state=new n(r),state.getContainerWidth=function(){return s}}),afterEach(function(){$(r.markerContainer).remove(),e.setServerTimezoneOffset(i)});var o=function(e,t){expect(state.getOffsetFromDate(new Date(e))).toEqual(t)};it("TimeBrowserState - offset calculation - time too old ",function(){var e=500,t=-state.markerLeftWidth;o(e,t)}),it("TimeBrowserState - offset calculation - start time",function(){var e=900,t=-state.markerLeftWidth;o(e,t)}),it("TimeBrowserState - offset calculation - end time",function(){var e=1e3,t=state.getMaximumOffset()-state.markerLeftWidth;o(e,t)}),it("TimeBrowserState - offset calculation - future time",function(){var e=2e3,t=state.getMaximumOffset()-state.markerLeftWidth;o(e,t)}),it("TimeBrowserState - offset calculation - quarter position",function(){var e=925,t=state.getMaximumOffset()/4-state.markerLeftWidth;o(e,t)}),it("TimeBrowserState - offset calculation - half way position",function(){var e=950,t=state.getMaximumOffset()/2-state.markerLeftWidth;o(e,t)});var u=function(e,t){expect(state.getDateFromOffset(e).getTime()).toEqual(t)};it("TimeBrowserState - date calculation - time too old ",function(){var e=-20,t=900;u(e,t)}),it("TimeBrowserState - date calculation - start time",function(){var e=0,t=900;u(e,t)}),it("TimeBrowserState - date calculation - end time",function(){var e=state.getMaximumOffset()-state.markerLeftWidth,t=1e3;u(e,t)}),it("TimeBrowserState - date calculation - future time",function(){var e=state.getMaximumOffset(),t=1e3;u(e,t)}),it("TimeBrowserState - date calculation - quarter position",function(){var e=state.getMaximumOffset()/4-state.markerLeftWidth,t=925;u(e,t)}),it("TimeBrowserState - date calculation - half way position",function(){var e=state.getMaximumOffset()/2-state.markerLeftWidth,t=950;u(e,t)})}),describe("TimeBrowserState Tests for different zoomIn cases",function(){var t,r,i,o={firstDate:new Date(910),lastDate:new Date(1e3),firstVisibleDate:new Date(910),lastVisibleDate:new Date(920),markerDate:new Date(915),isCurrentMode:!1},u={firstDate:new Date(910),lastDate:new Date(1e3),firstVisibleDate:new Date(960),lastVisibleDate:new Date(980),markerDate:new Date(970),isCurrentMode:!1},a={firstDate:new Date(900),lastDate:new Date(1e3),firstVisibleDate:new Date(940),lastVisibleDate:new Date(960),markerDate:new Date(950),isCurrentMode:!1};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(e,"getServerNow").andReturn(new Date(1e3)),t=new n(o),r=new n(u),i=new n(a),t.getContainerWidth=function(){return s},r.getContainerWidth=function(){return s},i.getContainerWidth=function(){return s}}),afterEach(function(){}),it("should zoom in for state1.",function(){t.zoomIn(),expect(t.firstDate.getTime()).toEqual(910),expect(t.lastDate.getTime()).toEqual(955),expect(t.firstVisibleDate.getTime()).toEqual(910),expect(t.lastVisibleDate.getTime()).toEqual(920)}),it("should zoom in for state2.",function(){r.zoomIn(),expect(r.firstDate.getTime()).toEqual(955),expect(r.lastDate.getTime()).toEqual(1e3),expect(r.firstVisibleDate.getTime()).toEqual(960),expect(r.lastVisibleDate.getTime()).toEqual(980)}),it("should zoom in for state3.",function(){i.zoomIn(),expect(i.firstDate.getTime()).toEqual(925),expect(i.lastDate.getTime()).toEqual(975),expect(i.firstVisibleDate.getTime()).toEqual(940),expect(i.lastVisibleDate.getTime()).toEqual(960)})}),describe("TimeBrowserState Tests for moveSelection ",function(){var t,r={firstDate:new Date(900),lastDate:new Date(1e3),firstVisibleDate:new Date(910),lastVisibleDate:new Date(920),markerDate:new Date(915),isCurrentMode:!1};beforeEach(function(){jasmine.Ajax.useMock(),spyOn(e,"getServerNow").andReturn(new Date(1e3)),t=new n(r),t.getContainerWidth=function(){return s}}),afterEach(function(){}),it("should move selected range forward to include marker",function(){t.setMarkerDate(new Date(930)),t.moveSelectedRangeToIncludeMarker(),expect(t.firstVisibleDate.getTime()).toEqual(925),expect(t.lastVisibleDate.getTime()).toEqual(935)}),it("should move selected range back to include marker",function(){t.setMarkerDate(new Date(909)),t.moveSelectedRangeToIncludeMarker(),expect(t.firstVisibleDate.getTime()).toEqual(904),expect(t.lastVisibleDate.getTime()).toEqual(914)})})})